/**
 * Created by 吴青龙 on 2014/12/17.
 * 功能：requireJS配置，在调用require.js前调用，其他文件无需再定义require.config
 */
if(typeof require_conf_run != 'object') (function () {
    var scriptEle = document.querySelectorAll("head > script");
    var baseUrl = scriptEle[scriptEle.length - 1].getAttribute("src").replace(/\/\w+(\.\w+)*$/, '');
    while(baseUrl.match(/\w+\/\.\.\//)) {
        baseUrl = baseUrl.replace(/\w+\/\.\.\//,'');
    }
    requirejs.config({
        //By default load any module IDs from js/lib
        baseUrl: baseUrl,
        //except, if the module ID starts with "app",
        //load it from the js/app directory. paths
        //config is relative to the baseUrl, and
        //never includes a ".js" extension since
        //the paths config could be for a directory.
        paths: {
//            jquery: 'http://code.enhance.cn/dist/libs/jquery/1.11.0/jquery'
            'jquery': 'jquery-1.10.2',
            'jquery-ui': 'jquery-ui/jquery-ui.min',
            'icheck': 'icheck/icheck.min',
            'ScrollBar': 'jquery.mCustomScrollbar.min',
            'mouseWheel': 'jquery.mousewheel.min',
            'recorder': 'FlashWavRecord/recorder',
            'swfobject': 'FlashWavRecord/swfobject',
            'circleBar': 'jquery.circliful.min',
            'calendario': 'jquery.calendario',
            'modernizr': 'modernizr.custom.63321',
            'zip': 'jszip.min',
            'switchButton': 'bootstrap-switch.min',
            'bootstrap':'bootstrap/js/bootstrap.min',
            'respond':'respond',
            'jPlayer': 'jquery.jplayer.min',
            'slick':'slick/1.4.1/slick',
            'imagePicker':'image-picker.min',
            'isLoading':'is-loading/jquery.isloading',
            'SuperSlide':'jquery.SuperSlide.2.1.1',
            'stars':'star-rating',
            'echarts':'echarts-all',
            'pie':'Pie',
            'iscroll':'iscroll/build/iscroll',

//      自定义模块
            'scrollTO': 'my_module/scrollto',
            'storage': 'my_module/storage',
            'submitAnswer': 'my_module/submitAnswer',
            'insertExcise': 'my_module/insertexcise',
            'countWord': 'my_module/count_word',
            'audioBar': 'my_module/audio_bar',
            'countTime': 'my_module/count_time',
            'canvas': 'my_module/canvas',
            'wav2mp3': 'my_module/mp3encoder/recordmp3',
            'mp3Lame': 'my_module/mp3encoder/libmp3lame',
            'audioIE8': 'my_module/audio_ie8',
            'ajaxLoading': 'my_module/ajax_loading',
            'dialog': 'my_module/dialog',
            'playerController': 'my_module/player_controller',
            'editText':'my_module/editText',

//      其他非AMD JS文件
            'speakingNoHTML5': '../toefl/speaking/js/speaking'
        },
        shim: {
            'circleBar': {
                deps: ['jquery']
            },
            'calendario': {
                deps: ['jquery']
            },
            'icheck': {
                deps: ['jquery']
            },
            'bootstrap':{
                deps: ['jquery']
            },
            'ScrollBar':{
                deps: ['jquery']
            },
            'slick':{
                deps: ['jquery']
            },
            'imagePicker':{
                deps: ['jquery']
            },
            'isLoading':{
                deps: ['jquery']
            },

            'SuperSlide':{
                deps: ['jquery']
            },

            'star':{
                deps: ['jquery']
            }
        }
    });
    require_conf_run = {};
})();