/**
 * Created by Administrator on 2015/9/6.
 */
define(['jquery','iscroll'],function($,Scroll){

    var $questionTemplates, $quesContainer, $quesType;
    var elements= {};
    var $imgZoomer = $('<div>').css({
        'position': 'absolute',
        'top': '0',
        'left': '0',
        'width': '100%',
        'height': '100%',
        'background': 'rgba(0,0,0,0.5)',
        'display': 'none'
    }).html('<div style="display: table;table-layout: fixed;width: 100%;height: 100%">' +
        '<div style="display: table-cell;vertical-align: middle;width: 100%;text-align: center;overflow: auto">' +
        '<img src="">' +
        '</div></div>').on('touchstart',function(){
        isMove = false;
    }).on('touchmove',function(){
        isMove = true;
    }).on('touchend',function(e){
        isMove || $(this).fadeOut();
        isMove = false;
    }).appendTo('body');
    /*初始化题目,设置题数,生成题目导航*/
    var initQuestion = function(data,dataArr){
        $questionTemplates = $('#questionTemplate');
        $quesType = $('#questionType');
        $quesContainer = $('#questionContainer');
        var $quesNav = $('.question-nav').children('.nav-container').children('nav');
        var $quesNum = $('#questionNum');
        /*设置标题栏题数*/
        var questionNum = data.questionNum;
        questionNum && $quesNum.text('/'+questionNum);
        /*设置题目导航*/
        var domNavItems = [];
        for(var i=0;i<questionNum;i++){
            var $item = $('<a>').text(i+1);
            if(dataArr[i].answer.answer !== null && dataArr[i].answer.answer !== undefined){
                $item.addClass('success');
            }
            domNavItems.push($item[0]);
        }
        $quesNav.html(domNavItems);
        elements.nav = $(domNavItems);
    };
    /*更新题目,*/
    var enterTime,thisData = null;
    var updateQuestion = function(data){
        thisData = data;
        enterTime = new Date();
        data.answer.enter_time = data.answer.enter_time || enterTime;
        var type = data.type;
        var $quesOrder = $('#questionOrder');
        /*获取题目HTML模板*/
        var $template = $questionTemplates.children('.'+type).clone();
        /*设置题目序号*/
        var questionOrder = data.questionOrder;
        $quesOrder.text(questionOrder);
        $template.find('.sub-question-order').text(questionOrder);
        switch (type){
            case 'READER':
                $quesType.text('阅读题');
                $('.passage-type',$template).text('[阅读题]');
                break;
            case 'FILL':
                $quesType.text('完形题');
                $('.passage-type',$template).text('[完形题]');
                break;
            case 'SINGLE_SELECT':
                $quesType.text('单选题');
                break;
        }
        switch (type){
            case 'READER':
            case 'FILL':
                $('.sub-question-num',$template).text('/'+data.subNum);
                $('.sub-question-order',$template).text(data.subOrder);
                $('.passage-content',$template).html(data.passage);
                var $passage = $('.passage',$template);
                var mouseY,isMove = false,height;
                $('.passage-slider',$template).on('touchstart',function(e){
                    e.stopPropagation();
                    isMove = true;
                    mouseY = e.originalEvent.touches[0].pageY;
                    height = $passage.height();
                });
                $(document).off('.slider');
                $(document).on('touchmove.slider',function(e){
                    if(isMove){
                        $passage.css('max-height','none');
                        $passage.siblings('.subject.scroll').css('max-height','none');
                        height = height+ e.originalEvent.touches[0].pageY-mouseY;
                        if($passage.offset().top + height < $quesContainer.offset().top + $quesContainer.height()/3*2 && height > 14){
                            $passage.height(height);
                            $passage.siblings('.subject.scroll').height($passage.parent().height() - height);
                        }
                        mouseY = e.originalEvent.touches[0].pageY;
                        e.stopPropagation();
                        e.preventDefault();
                    }
                }).on('touchend.slider',function(e){
                    isMove = false;
                    $passage.trigger('slideend');
                });
            case 'SINGLE_SELECT':
                $('.js-question-order',$template).text(data.subOrder);
                /*设置题目问题: 去掉最前面的p标签*/
                var titleHtml = (data.question||'').replace(/^(\s*)<p>([\s\S]*?)<\/p>/,'$1$2')
                    .replace(/(\/[\w-]+)*\.(jpg|png)/,'<img class="scalable-img" alt="图片加载失败" src="http://my.xdf.cn$&" width="100%">');
                $template.find('.js-question-title').html(titleHtml).find('.scalable-img').click(function(){
                    $imgZoomer.fadeIn().find('img').attr('src',$(this).attr('src'));
                });
                /*生成题目选项*/
                var options = data.options || [];
                var $optionList = $template.find('.option-list');
                var $optionItem = $optionList.children('.option-item');
                var $contentList = $template.find('.content-list');
                var $contentItem = $contentList.children('.content-item');
                for(var i=1;i<options.length;i++){
                    $optionItem = $optionItem.clone();
                    $optionItem.find('.item-order i').text(String.fromCharCode(65+i));
                    $optionList.append($optionItem);
                    $contentItem = $contentItem.clone();
                    $contentItem.find('.item-order i').text(String.fromCharCode(65+i));
                    $contentList.append($contentItem);
                }
                var $itemContent = $('.item-content',$template).each(function(index){
                    $(this).html(options[index]);
                });
                var $optionItems = $('.option-item',$optionList);
                var $contentItems = $('.content-item',$optionList);
                break;
        }

        /*更新问题区域*/
        $quesContainer.html($template);
        /*设置滚动*/
        $passage = $('.passage.scroll',$template);
        $passage.each(function(){
            var $selfPassage = $(this);
            var iscrollPassage = new Scroll(this,{
                scrollbars: false,
                click: true,
                disableMouse: true,
                disablePointer: true
            });
            $selfPassage.on('slideend',function(){
                setTimeout(function(){
                    iscrollPassage.refresh();
                },0);
            });
            elements.passageScroller = iscrollPassage;
        });
        var subject = $template.find('.subject.scroll');
        subject.each(function(){
            var iscrollSubject = new Scroll(this,{
                scrollbars: false,
                click: true,
                disableMouse: true,
                disablePointer: true
            });
            $passage.on('slideend',function(){
                setTimeout(function(){
                    iscrollSubject.refresh();
                },0);
            });
            elements.subjectScroller = iscrollSubject;
        });

        elements.options = $optionItems;
        elements.contents = $contentItems;
        elements.contentText = $itemContent;
        elements.template = $template;
    };
    var onExitQuestion = function(){
        thisData.answer.state_time = ((thisData.answer.state_time-0)||0)+Math.round((new Date() - enterTime)/1000);
    };

    return {
        init: function(data,dataArr){
            initQuestion(data,dataArr);
        },
        generate: function(data){
            updateQuestion(data);
        },
        getNav: function(){
            return elements.nav;
        },
        getOptions: function(){
            return elements.options;
        },
        getContents: function(){
            return elements.contents;
        },
        getContentsText: function(){
            return elements.contentText;
        },
        getAll: function(){
            return elements.template;
        },
        exit: function(){
            onExitQuestion();
        },
        getObj: function(key){
            return elements[key];
        }
    }
});