/**
 * Created by Administrator on 2014/12/8.
 // */

/**显示/隐藏时间，并将时间信息存入表单
 * */
requirejs(['jquery', 'js/count_time.js'], function ($, T) {
    $(function () {

        var $overTime = $('input[name="overTime"]', '#js_practiseForm');
        if ($overTime.length < 1) {
            $overTime = $('<input>', {
                'type': 'hidden',
                'value': '',
                'name': 'overTime'
            }).appendTo('#js_practiseForm');
        }

        var $beginTime = $('input[name="beginTime"]', '#js_practiseForm');
        var nBeginTime = 3600;
        if ($beginTime.length > 0) {/*不存在beginTime表单项，则使用默认1小时开始倒计*/
            nBeginTime = $beginTime.val();
        }

        T({
            startTime: nBeginTime,
            timeOverDialog: false,/*需要时间结束提示框*/
            dialogSel: '.ui-dialog-time-over,#ui-dialog-time-over',
            timeDivID: 'RecordTime',/*显示时间的HTML元素ID*/
            buttonID: 'btn-hid',/*显示隐藏时间的按钮ID*/
            onReady: function() {
                $overTime.val(nBeginTime);
            },
            onRun: function () {/*倒计时中不停运行的函数*/
                $overTime.val(T.currentS + T.currentM * 60 + T.currentH * 3600);/*写表单overTime项*/
            },
            onOver: function() {/*时间结束，根据data-timeover-url提交表单*/
                requirejs(['submitAnswer','storage'],function(submitAnswer,ST){
                    var url = $('#RecordTime').data('timeover-url');
                    if(url != undefined && url.length > 0) {
                        $("#js_practiseForm").attr("action", url);
                    }
                    if(url != '#') {
                        ST.reset('mockTime');/*没起作用，再count_time中的fover实现*/
                        submitAnswer('#js_practiseForm')
                    }
                });
            }
        });
        $('audio[autoplay="autoplay"]').on('ended',function() {/*有自动播放的audio则暂停计时,结束后再继续*/
            T.run();
        }).length > 0 ? T.pause():0;
    });
});
